proc ddh_freq_selector { name variable } {
   frame $name
   label $name.x -text "X" -relief raised -pady 0 -bd 1 
   label $name.y -text "Y" -relief raised -pady 0 -bd 1
   label $name.z -text "Z" -relief raised -pady 0 -bd 1

   bind $name.x <ButtonPress-1> "%W configure -relief sunken;
	$name.y configure -relief raised;
	$name.z configure -relief raised;
	uplevel #0 \"set $variable x\""

   bind $name.y <ButtonPress-1> "%W configure -relief sunken;
	$name.x configure -relief raised;
	$name.z configure -relief raised;
	uplevel #0 \"set $variable y\""

   bind $name.z <ButtonPress-1> "%W configure -relief sunken;
	$name.x configure -relief raised;
	$name.y configure -relief raised;
	uplevel #0 \"set $variable z\""

   pack $name.x $name.y $name.z -side left -padx 0
   return $name
}

proc ddh_amp_selector { name variable } {
   frame $name
   label $name.x -text "X" -relief raised -pady 0 -bd 1 
   label $name.y -text "Y" -relief raised -pady 0 -bd 1
   label $name.z -text "Z" -relief raised -pady 0 -bd 1
   label $name.n -text "N" -relief raised -pady 0 -bd 1

   bind $name.x <ButtonPress-1> "%W configure -relief sunken;
	$name.y configure -relief raised;
	$name.z configure -relief raised;
	$name.n configure -relief raised;
	uplevel #0 \"set $variable x\""

   bind $name.y <ButtonPress-1> "%W configure -relief sunken;
	$name.x configure -relief raised;
	$name.z configure -relief raised;
	$name.n configure -relief raised;
	uplevel #0 \"set $variable y\""

   bind $name.z <ButtonPress-1> "%W configure -relief sunken;
	$name.x configure -relief raised;
	$name.y configure -relief raised;
	$name.n configure -relief raised;
	uplevel #0 \"set $variable z\""

   bind $name.n <ButtonPress-1> "%W configure -relief sunken;
	$name.x configure -relief raised;
	$name.y configure -relief raised;
	$name.z configure -relief raised;
	uplevel #0 \"set $variable n\""

   pack $name.x $name.y $name.z $name.n -side left -padx 0
   return $name
}

proc ddhwave_makeframe {} {

   global ddhwave_axis_freq
   global ddhwave_axis_amp1
   global ddhwave_axis_amp2
   global ddhwave_amp1
   global ddhwave_decay1
   global ddhwave_amp2
   global ddhwave_decay2
   global ddhwave_freq
   global ddhwave_offset1
   global ddhwave_offset2
   global ddhwave_additive
   global ddhwave_frequnits

   set ddhwave_axis_freq        x
   set ddhwave_axis_amp1        y
   set ddhwave_axis_amp2        z
   set ddhwave_amp1           1.0
   set ddhwave_decay1         50.0
   set ddhwave_amp2           1.0
   set ddhwave_decay2         50.0
   set ddhwave_freq             4
   set ddhwave_offset1          0
   set ddhwave_offset2          0
   set ddhwave_additive         1
   set ddhwave_frequnits        0

   toplevel .ddhwave
   wm title .ddhwave "Wave3D - 1.00"
   wm transient .ddhwave [winfo toplevel [winfo parent .ddhwave]]

   set width 6
   set ypad 3

   # Space
   frame .ddhwave.frmspace0
   pack .ddhwave.frmspace0 -side top -fill x -pady $ypad

   # Frequency axis
   frame .ddhwave.frmfreqa
   pack .ddhwave.frmfreqa -side top -fill x
   label .ddhwave.frmfreqa.lblaxisfreq -text "Frequency axis   "
   ddh_freq_selector .ddhwave.frmfreqa.axisfreq ddhwave_axis_freq
   pack .ddhwave.frmfreqa.lblaxisfreq -anchor w -side left
   pack .ddhwave.frmfreqa.axisfreq -anchor e -side right
   if { $ddhwave_axis_freq == "y" } {
      .ddhwave.frmfreqa.axisfreq.y configure -relief sunken
   } else {
      if { $ddhwave_axis_freq == "z" } {
         .ddhwave.frmfreqa.axisfreq.z configure -relief sunken
      } else {
         set $ddhwave_axis_freq x
         .ddhwave.frmfreqa.axisfreq.x configure -relief sunken
      }
   }

   # Frequency
   frame .ddhwave.frmfreq
   pack .ddhwave.frmfreq -side top -fill x
   label .ddhwave.frmfreq.lblfreq -text "Frequency   "
   spinbox .ddhwave.frmfreq.freq -from 0.0 -increment 0.1 -to 100.0 -textvariable ddhwave_freq -width $width
   pack .ddhwave.frmfreq.lblfreq -anchor w -side left
   pack .ddhwave.frmfreq.freq -anchor e -side right
   add_balloon .ddhwave.frmfreq.freq "Wave frequency"

   # Frequency type
   frame .ddhwave.frmfreqtype
   pack .ddhwave.frmfreqtype -side top -fill x
   checkbutton .ddhwave.frmfreqtype.chkfreqtype -text "Frequency expressed in units" -variable ddhwave_frequnits
   pack .ddhwave.frmfreqtype.chkfreqtype -anchor w
   add_balloon .ddhwave.frmfreqtype.chkfreqtype "Check to specify frequency in units.  If unchecked, frequency is the number of waveforms over the entire selection"




   # Space
   frame .ddhwave.frmspace1
   pack .ddhwave.frmspace1 -side top -fill x -pady $ypad

   # Amplitude axis 1
   frame .ddhwave.frmampa1
   pack .ddhwave.frmampa1 -side top -fill x
   label .ddhwave.frmampa1.lblaxisamp -text "Amplitude axis 1 "
   ddh_amp_selector .ddhwave.frmampa1.axisamp ddhwave_axis_amp1
   pack .ddhwave.frmampa1.lblaxisamp -anchor w -side left
   pack .ddhwave.frmampa1.axisamp -anchor e -side right
   add_balloon .ddhwave.frmampa1.axisamp "Pick X,Y,Z or None"
   if { $ddhwave_axis_amp1 == "x" } {
      .ddhwave.frmampa1.axisamp.x configure -relief sunken
   } else {
      if { $ddhwave_axis_amp1 == "y" } {
         .ddhwave.frmampa1.axisamp.y configure -relief sunken
      } else {
         if { $ddhwave_axis_amp1 == "z" } {
            .ddhwave.frmampa1.axisamp.z configure -relief sunken
         } else {
            set $ddhwave_axis_amp1 n
            .ddhwave.frmampa1.axisamp.n configure -relief sunken
         }
      }
   }


   # Amplitude 1
   frame .ddhwave.frmamp1
   pack .ddhwave.frmamp1 -side top -fill x
   label .ddhwave.frmamp1.lblamp -text "Amplitude   "
   spinbox .ddhwave.frmamp1.amp -from 0.0 -increment 0.1 -to 1000.0 -textvariable ddhwave_amp1 -width $width
   pack .ddhwave.frmamp1.lblamp -anchor w -side left
   pack .ddhwave.frmamp1.amp -anchor e -side right
   add_balloon .ddhwave.frmamp1.amp "Amplitude (height) of wave"

   # decay 1
   frame .ddhwave.frmdecay1
   pack .ddhwave.frmdecay1 -side top -fill x
   label .ddhwave.frmdecay1.lbldecay -text "Decay %  "
   spinbox .ddhwave.frmdecay1.decay -from 0.0 -increment 0.1 -to 1000.0 -textvariable ddhwave_decay1 -width $width
   pack .ddhwave.frmdecay1.lbldecay -anchor w -side left
   pack .ddhwave.frmdecay1.decay -anchor e -side right
   add_balloon .ddhwave.frmdecay1.decay "Amplitude Decay % of original size"

   # Offset 1
   frame .ddhwave.frmoffset1
   pack .ddhwave.frmoffset1 -side top -fill x
   label .ddhwave.frmoffset1.lbloffset -text "Offset %   "
   spinbox .ddhwave.frmoffset1.offset -from 0.0 -increment 0.5 -to 100.0 -textvariable ddhwave_offset1 -width $width
   pack .ddhwave.frmoffset1.lbloffset -anchor w -side left
   pack .ddhwave.frmoffset1.offset -anchor e -side right
   add_balloon .ddhwave.frmoffset1.offset "Offset percentage to start wave"





   # Space
   frame .ddhwave.frmspace2
   pack .ddhwave.frmspace2 -side top -fill x -pady $ypad


   # Amplitude axis 2
   frame .ddhwave.frmampa2
   pack .ddhwave.frmampa2 -side top -fill x
   label .ddhwave.frmampa2.lblaxisamp -text "Amplitude axis 2 "
   ddh_amp_selector .ddhwave.frmampa2.axisamp ddhwave_axis_amp2
   pack .ddhwave.frmampa2.lblaxisamp -anchor w -side left
   pack .ddhwave.frmampa2.axisamp -anchor e -side right
   add_balloon .ddhwave.frmampa2.axisamp "Pick X,Y,Z or None"
   if { $ddhwave_axis_amp2 == "x" } {
      .ddhwave.frmampa2.axisamp.x configure -relief sunken
   } else {
      if { $ddhwave_axis_amp2 == "y" } {
         .ddhwave.frmampa2.axisamp.y configure -relief sunken
      } else {
         if { $ddhwave_axis_amp2 == "z" } {
            .ddhwave.frmampa2.axisamp.z configure -relief sunken
         } else {
            set $ddhwave_axis_amp2 n
            .ddhwave.frmampa2.axisamp.n configure -relief sunken
         }
      }
   }

   # Amplitude 2
   frame .ddhwave.frmamp2
   pack .ddhwave.frmamp2 -side top -fill x
   label .ddhwave.frmamp2.lblamp -text "Amplitude   "
   spinbox .ddhwave.frmamp2.amp -from 0.0 -increment 0.1 -to 1000.0 -textvariable ddhwave_amp2 -width $width
   pack .ddhwave.frmamp2.lblamp -anchor w -side left
   pack .ddhwave.frmamp2.amp -anchor e -side right
   add_balloon .ddhwave.frmamp2.amp "Amplitude (height) of wave"

   # decay 2
   frame .ddhwave.frmdecay2
   pack .ddhwave.frmdecay2 -side top -fill x
   label .ddhwave.frmdecay2.lbldecay -text "Decay %  "
   spinbox .ddhwave.frmdecay2.decay -from 0.0 -increment 0.1 -to 1000.0 -textvariable ddhwave_decay2 -width $width
   pack .ddhwave.frmdecay2.lbldecay -anchor w -side left
   pack .ddhwave.frmdecay2.decay -anchor e -side right
   add_balloon .ddhwave.frmdecay2.decay "Amplitude Decay % of original size"

   # Offset 2
   frame .ddhwave.frmoffset2
   pack .ddhwave.frmoffset2 -side top -fill x
   label .ddhwave.frmoffset2.lbloffset -text "Offset %   "
   spinbox .ddhwave.frmoffset2.offset -from 0.0 -increment 0.5 -to 100.0 -textvariable ddhwave_offset2 -width $width
   pack .ddhwave.frmoffset2.lbloffset -anchor w -side left
   pack .ddhwave.frmoffset2.offset -anchor e -side right
   add_balloon .ddhwave.frmoffset2.offset "Offset percentage to start wave"





   # Space
   frame .ddhwave.frmspace3
   pack .ddhwave.frmspace3 -side top -fill x -pady $ypad

   # Options
   frame .ddhwave.frmopts
   pack .ddhwave.frmopts -side top -fill x

   # Additive
   checkbutton .ddhwave.frmopts.chkadditive -text "Additive" -variable ddhwave_additive
   pack .ddhwave.frmopts.chkadditive -anchor w
   add_balloon .ddhwave.frmopts.chkadditive "Check to add values to existing coordinates.\nUncheck to reposition vertices completely to adhere to wave."




   # Space
   frame .ddhwave.frmspace4
   pack .ddhwave.frmspace4 -side top -fill x -pady $ypad

   # Apply waveform
   frame .ddhwave.frmbtn
   pack .ddhwave.frmbtn -side top -fill x





   button .ddhwave.frmbtn.btnapplyrand -text "Apply wave with random offset" -command {
      eval ac3d ddhwave_go $ddhwave_axis_freq $ddhwave_axis_amp1 $ddhwave_axis_amp2 $ddhwave_freq $ddhwave_amp1 $ddhwave_amp2 $ddhwave_decay1 $ddhwave_decay2 "random" "random" $ddhwave_additive $ddhwave_frequnits
   }
   pack .ddhwave.frmbtn.btnapplyrand -expand 1 -fill x

   button .ddhwave.frmbtn.btnapply -text "Apply wave" -command {
      eval ac3d ddhwave_go $ddhwave_axis_freq $ddhwave_axis_amp1 $ddhwave_axis_amp2 $ddhwave_freq $ddhwave_amp1 $ddhwave_amp2 $ddhwave_decay1 $ddhwave_decay2 $ddhwave_offset1 $ddhwave_offset2 $ddhwave_additive $ddhwave_frequnits
   }
   pack .ddhwave.frmbtn.btnapply -expand 1 -fill x

}







proc ddhwave_dialog {} {

   if ![winfo exists .ddhwave] {
      ddhwave_makeframe
   }

   wm deiconify .ddhwave
   centre_window_on_screen .ddhwave

}

